
- name: hash password
  set_fact:
      kypo_hashed_password: '{{ kypo_password | password_hash("sha512",65534|random(seed=kypo_user)|string) }}'
  when: kypo_password is defined and kypo_password

- name: create KYPO user
  user:
      createhome: yes
      name: '{{ kypo_user }}'
      password: '{{ kypo_hashed_password | default(omit) }}'
      shell: /bin/bash
      state: present

- name: ensure existence of .ssh directory of KYPO user
  file:
      dest: /home/{{ kypo_user }}/.ssh
      state: directory

- name: add SSH public key to authorized keys
  copy:
      src: id_rsa_api.pub
      dest: /home/{{ kypo_user }}/.ssh/authorized_keys
      mode: 0644
      owner: '{{ kypo_user }}'
      group: '{{ kypo_user }}'

- name: enable ssh authentication using password
  lineinfile:
      dest: /etc/ssh/sshd_config
      regexp: '^#?[ \t]*{{ item.key }} (yes|no)$'
      line: '{{ item.key }} {{ item.value }}'
  with_items:
      - key: PasswordAuthentication
        value: '{% if kypo_hashed_password is defined and kypo_hashed_password %}yes{% else %}no{% endif %}'
      - key: PubkeyAuthentication
        value: 'yes'
  notify: kypo_sshd_restart

- name: install sudo packages
  package:
      name: sudo
      state: present

- name: ensure existence of sudoers directory
  file:
      dest: /etc/sudoers.d
      state: directory

- name: grant root privileges to KYPO user
  lineinfile:
      dest: /etc/sudoers.d/kypo
      create: yes
      line: '{{ kypo_user }} ALL=(ALL) NOPASSWD: ALL'
      validate: '/usr/sbin/visudo -cf %s'

